Lucene++ - a full-featured, c++ search engine
API Documentation

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes
Lucene::DefaultSkipListReader Class Reference

Implements the skip list reader for the default posting list format that stores positions and payloads. More...

`#include <DefaultSkipListReader.h>`

Inheritance diagram for Lucene::DefaultSkipListReader:

## Public Member Functions

| DefaultSkipListReader (const IndexInputPtr &skipStream, int32_t maxSkipLevels, int32_t skipInterval)
virtual | ~DefaultSkipListReader ()
virtual String | getClassName ()
boost::shared_ptr< DefaultSkipListReader > | shared_from_this ()
void | init (int64_t skipPointer, int64_t freqBasePointer, int64_t proxBasePointer, int32_t df, bool storesPayloads)
int64_t | getFreqPointer ()
| Returns the freq pointer of the doc to which the last call of `MultiLevelSkipListReader#skipTo(int)` has skipped.
int64_t | getProxPointer ()
| Returns the prox pointer of the doc to which the last call of `MultiLevelSkipListReader#skipTo(int)` has skipped.
int32_t | getPayloadLength ()
| Returns the payload length of the payload stored just before the doc to which the last call of `MultiLevelSkipListReader#skipTo(int)` has skipped.
Public Member Functions inherited from Lucene::MultiLevelSkipListReader
| MultiLevelSkipListReader (const IndexInputPtr &skipStream, int32_t maxSkipLevels, int32_t skipInterval)
virtual | ~MultiLevelSkipListReader ()
boost::shared_ptr< MultiLevelSkipListReader > | shared_from_this ()
virtual int32_t | getDoc ()
| Returns the id of the doc to which the last call of `skipTo(int)` has skipped.
virtual int32_t | skipTo (int32_t target)
| Skips entries to the first beyond the current whose document number is greater than or equal to target. Returns the current doc count.
virtual void | close ()
virtual void | init (int64_t skipPointer, int32_t df)
| Initializes the reader.
Public Member Functions inherited from Lucene::LuceneObject
virtual | ~LuceneObject ()
virtual void | initialize ()
| Called directly after instantiation to create objects that depend on this object being fully constructed.
virtual LuceneObjectPtr | clone (const LuceneObjectPtr &other=LuceneObjectPtr())
| Return clone of this object.
virtual int32_t | hashCode ()
| Return hash code for this object.
virtual bool | equals (const LuceneObjectPtr &other)
| Return whether two objects are equal.
virtual int32_t | compareTo (const LuceneObjectPtr &other)
| Compare two objects.
virtual String | toString ()
| Returns a string representation of the object.
Public Member Functions inherited from Lucene::LuceneSync
virtual | ~LuceneSync ()
virtual SynchronizePtr | getSync ()
| Return this object synchronize lock.
virtual LuceneSignalPtr | getSignal ()
| Return this object signal.
virtual void | lock (int32_t timeout=0)
| Lock this object using an optional timeout.
virtual void | unlock ()
| Unlock this object.
virtual bool | holdsLock ()
| Returns true if this object is currently locked by current thread.
virtual void | wait (int32_t timeout=0)
| Wait for signal using an optional timeout.
virtual void | notifyAll ()
| Notify all threads waiting for signal.

## Static Public Member Functions

static String | _getClassName ()
Static Public Member Functions inherited from Lucene::MultiLevelSkipListReader
static String | _getClassName ()

## Protected Member Functions

virtual void | seekChild (int32_t level)
| Seeks the skip entry on the given level.
virtual void | setLastSkipData (int32_t level)
| Copies the values of the last read skip entry on this level.
virtual int32_t | readSkipData (int32_t level, const IndexInputPtr &skipStream)
| Subclasses must implement the actual skip data encoding in this method.
Protected Member Functions inherited from Lucene::MultiLevelSkipListReader
virtual bool | loadNextSkip (int32_t level)
virtual void | loadSkipLevels ()
| Loads the skip levels.
Protected Member Functions inherited from Lucene::LuceneObject
| LuceneObject ()

## Protected Attributes

bool | currentFieldStoresPayloads
Collection< int64_t > | freqPointer
Collection< int64_t > | proxPointer
Collection< int32_t > | payloadLength
int64_t | lastFreqPointer
int64_t | lastProxPointer
int32_t | lastPayloadLength
Protected Attributes inherited from Lucene::MultiLevelSkipListReader
int32_t | maxNumberOfSkipLevels
| the maximum number of skip levels possible for this index
int32_t | numberOfSkipLevels
| number of levels in this skip list
int32_t | numberOfLevelsToBuffer
| Defines the number of top skip levels to buffer in memory. Reducing this number results in less memory usage, but possibly slower performance due to more random I/Os. Please notice that the space each level occupies is limited by the skipInterval. The top level can not contain more than skipLevel entries, the second top level can not contain more than skipLevel^2 entries and so forth.
int32_t | docCount
bool | haveSkipped
Collection< IndexInputPtr > | skipStream
Collection< int64_t > | skipPointer
Collection< int32_t > | skipInterval
Collection< int32_t > | numSkipped
Collection< int32_t > | skipDoc
int32_t | lastDoc
Collection< int64_t > | childPointer
int64_t | lastChildPointer
bool | inputIsBuffered
Protected Attributes inherited from Lucene::LuceneSync
SynchronizePtr | objectLock
LuceneSignalPtr | objectSignal

## Detailed Description

Implements the skip list reader for the default posting list format that stores positions and payloads.

## Constructor & Destructor Documentation

## ◆ DefaultSkipListReader()

Lucene::DefaultSkipListReader::DefaultSkipListReader | ( | const IndexInputPtr & | skipStream,
|  | int32_t | maxSkipLevels,
|  | int32_t | skipInterval )

References Lucene::MultiLevelSkipListReader::skipInterval, and Lucene::MultiLevelSkipListReader::skipStream.

Referenced by _getClassName().

## ◆ ~DefaultSkipListReader()

virtual Lucene::DefaultSkipListReader::~DefaultSkipListReader | ( |  | ) |

virtual

## Member Function Documentation

## ◆ _getClassName()

String Lucene::DefaultSkipListReader::_getClassName | ( |  | ) |

inline static

References DefaultSkipListReader().

## ◆ getClassName()

virtual String Lucene::DefaultSkipListReader::getClassName | ( |  | ) |

inline virtual

Reimplemented from Lucene::MultiLevelSkipListReader.

## ◆ getFreqPointer()

int64_t Lucene::DefaultSkipListReader::getFreqPointer | ( |  | ) |

Returns the freq pointer of the doc to which the last call of `MultiLevelSkipListReader#skipTo(int)` has skipped.

## ◆ getPayloadLength()

int32_t Lucene::DefaultSkipListReader::getPayloadLength | ( |  | ) |

Returns the payload length of the payload stored just before the doc to which the last call of `MultiLevelSkipListReader#skipTo(int)` has skipped.

## ◆ getProxPointer()

int64_t Lucene::DefaultSkipListReader::getProxPointer | ( |  | ) |

Returns the prox pointer of the doc to which the last call of `MultiLevelSkipListReader#skipTo(int)` has skipped.

## ◆ init()

void Lucene::DefaultSkipListReader::init | ( | int64_t | skipPointer,
|  | int64_t | freqBasePointer,
|  | int64_t | proxBasePointer,
|  | int32_t | df,
|  | bool | storesPayloads )

References Lucene::MultiLevelSkipListReader::skipPointer.

## ◆ readSkipData()

virtual int32_t Lucene::DefaultSkipListReader::readSkipData | ( | int32_t | level,
|  | const IndexInputPtr & | skipStream )

protected virtual

Subclasses must implement the actual skip data encoding in this method.

Implements Lucene::MultiLevelSkipListReader.

References Lucene::MultiLevelSkipListReader::skipStream.

## ◆ seekChild()

virtual void Lucene::DefaultSkipListReader::seekChild | ( | int32_t | level | ) |

protected virtual

Seeks the skip entry on the given level.

Reimplemented from Lucene::MultiLevelSkipListReader.

## ◆ setLastSkipData()

virtual void Lucene::DefaultSkipListReader::setLastSkipData | ( | int32_t | level | ) |

protected virtual

Copies the values of the last read skip entry on this level.

Reimplemented from Lucene::MultiLevelSkipListReader.

## ◆ shared_from_this()

boost::shared_ptr< DefaultSkipListReader > Lucene::DefaultSkipListReader::shared_from_this | ( |  | ) |

inline

## Field Documentation

## ◆ currentFieldStoresPayloads

bool Lucene::DefaultSkipListReader::currentFieldStoresPayloads

protected

## ◆ freqPointer

Collection<int64_t> Lucene::DefaultSkipListReader::freqPointer

protected

## ◆ lastFreqPointer

int64_t Lucene::DefaultSkipListReader::lastFreqPointer

protected

## ◆ lastPayloadLength

int32_t Lucene::DefaultSkipListReader::lastPayloadLength

protected

## ◆ lastProxPointer

int64_t Lucene::DefaultSkipListReader::lastProxPointer

protected

## ◆ payloadLength

Collection<int32_t> Lucene::DefaultSkipListReader::payloadLength

protected

## ◆ proxPointer

Collection<int64_t> Lucene::DefaultSkipListReader::proxPointer

protected

The documentation for this class was generated from the following file:

- DefaultSkipListReader.h

clucene.sourceforge.net